from abc import ABC, abstractmethod
import json
from string import Template


GCP_ICON_URL = "https://avatars.githubusercontent.com/u/2810941?s=200&v=4"

class AdaptiveCard(ABC):
    def __init__(self):
        self.title = None
        self.summary = None
        self.action_title = None
        self.action_url = None
        self.facts = []

    def add_fact(self, name, value):
        self.facts.append({"title": name, "value": value})

    def get_card(self) -> dict:
        actions = []
        # add action
        if (self.action_title and self.action_url):
            actions.append(
                {
                    "type": "Action.OpenUrl",
                    "title": self.action_title,
                    "url": self.action_url,
                    "iconUrl": GCP_ICON_URL
                }
            )

        return {
          "type": "message",
          "attachments": [
            {
              "contentType": "application/vnd.microsoft.card.adaptive",
              "contentUrl": None,
              "content": { # Structure from here generated by https://adaptivecards.io/designer
                "type": "AdaptiveCard",
                "$schema": "http://adaptivecards.io/schemas/adaptive-card.json", # note the escaped $$
                "version": "1.2",
                "body": [
                  {
                    "type": "Container",
                    "items": [
                      {
                        "type": "ColumnSet",
                        "columns": [
                          {
                            "type": "Column",
                            "items": [
                              {
                                "type": "Image",
                                "url": GCP_ICON_URL,
                                "height": "30px"
                              }
                            ],
                            "width": "auto"
                          },
                          {
                            "type": "Column",
                            "items": [
                              {
                                "type": "TextBlock",
                                "text": self.title,
                                "fontType": "Default",
                                "style": "heading",
                              },
                              {
                                "type": "TextBlock",
                                "text": self.summary,
                                "wrap": True
                              }
                            ],
                            "width": "stretch"
                          }
                        ]
                      }
                    ]
                  },
                  {
                    "type": "Container",
                    "items": [
                      {
                        "type": "TextBlock",
                        "text": "Summary",
                        "wrap": True,
                        "style": "heading"
                      }
                    ]
                  },
                  {
                    "type": "FactSet",
                    "facts": self.facts
                  },
                  {
                    "type": "ActionSet",
                    "actions": actions
                  }
                ]
              }
            }
          ]
        }

    def to_json(self):
        return json.dumps(self.get_card())
